Bug 120924 - anaconda doesn't seem to get rtl languages right
anaconda doesn't seem to get rtl languages right
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: anaconda (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jeremy Katz
Mike McLean
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-04-15 07:35 EDT by Alexander Larsson
Modified: 2007-11-30 17:10 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-08-15 12:06:27 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Alexander Larsson 2004-04-15 07:35:10 EDT
Looking at http://people.redhat.com/~katzj/anaconda-farsi.png it seems
like the anaconda UI wasn't properly mirrored, even though the text is
RTL. 

What happens wrt to RTL mirroring in gtk+ is:
At init (in gtk_parse_args) the default direction is set based on the
current language, like this:

    char *e = _("default:LTR");
    if (strcmp (e, "default:RTL")==0) {
      gtk_widget_set_default_direction (GTK_TEXT_DIR_RTL);
    } else if (strcmp (e, "default:LTR")) {
      g_warning ("Whoever translated default:LTR did so wrongly.\n");
    }

If you change the locale at runtime, after initializing gtk you need
to call gtk_widget_set_default_direction with the correct flags. You
can probably look at dgettext("gtk20", "default:LTR") after you've
changed the language, and use code similar to above to set the direction.
Comment 1 Jeremy Katz 2004-04-15 14:37:48 EDT
Thanks for the complete description of the fix... committed to cvs,
see http://people.redhat.com/~katzj/anaconda-farsi-2.png

Note You need to log in before you can comment on or make changes to this bug.